indexing

	description: "Base for structured fields with parameters."

	author: "Berend de Boer"
	date: "$Date: 2003/01/09 $"
	revision: "$Revision: #1 $"


deferred class

	EPX_MIME_FIELD_WITH_PARAMETERS


inherit

	EPX_MIME_STRUCTURED_FIELD



feature {NONE} -- Initialization

	make_parameters is
			-- Initialize Content-Type.
		do
			create parameters.make (16)
		end


feature -- State

	parameters: DS_HASH_TABLE [EPX_MIME_PARAMETER, STRING]
			-- Optional list of parameters.



feature {NONE} -- Implementation

	is_every_parameter_name_lower_case: BOOLEAN is
			-- Every parameter should have its name in lower-case, makes
			-- finding parameters a lot easier. True if every parameter
			-- name is lower-case, and if every parameter can be found,
			-- i.e. the key was lowercase as well.
		local
			cursor: DS_LINEAR_CURSOR [EPX_MIME_PARAMETER]
			parameter_name: STRING
		do
			from
				Result := True
				cursor := parameters.new_cursor
				cursor.start
			until
				not Result or else cursor.after
			loop
				parameter_name := clone (cursor.item.name)
				parameter_name.to_lower
				Result :=
					cursor.item.name.is_equal (parameter_name) and
					parameters.has (cursor.item.name)
				cursor.forth
			end
		end


invariant

	parameters_not_void: parameters /= Void
	all_parameter_names_are_lower_case: is_every_parameter_name_lower_case
			-- for_each p in parameters it_holds p.is_all_lower_case

end
