indexing

	description: "eposix's mime parser."

	standards: "Based on RFC 822, 2045 and 2047."

	implementation:
		"1. Not all recognized field names are parsed.%
		%   Should be easy to expand if you wish to do real message parsing.%
		%2. RFC821 defines maximum line lengths of 1000 characters. This parser%
		%   doesn't care.%
		%3. Fields to add: Content-Type-Encoding; Content-Description"

	author: "Berend de Boer"
	date: "$Date: 2003/01/09 $"
	revision: "$Revision: #1 $"

class

	EPX_MIME_PARSER


inherit

	EPX_MIME_SCANNER
		rename
			make as make_scanner
		redefine
			wrap
		end

	YY_PARSER_SKELETON [ANY]
		rename
			parse as do_parse
		redefine
			make,
			report_error
		end


creation

	make,
	make_from_file,
	make_from_file_descriptor



feature {NONE} -- Implementation

	yy_build_parser_tables is
			-- Build parser tables.
		do
			yytranslate ?= yytranslate_template
			yyr1 ?= yyr1_template
			yyr2 ?= yyr2_template
			yydefact ?= yydefact_template
			yydefgoto ?= yydefgoto_template
			yypact ?= yypact_template
			yypgoto ?= yypgoto_template
			yytable ?= yytable_template
			yycheck ?= yycheck_template
		end

feature {NONE} -- Semantic actions

	yy_do_action (yy_act: INTEGER) is
			-- Execute semantic action.
		local
			yyval2: EPX_MIME_FIELD
			yyval4: EPX_MIME_FIELD_CONTENT_DISPOSITION
			yyval6: EPX_MIME_FIELD_CONTENT_LENGTH
			yyval5: EPX_MIME_FIELD_CONTENT_TYPE
			yyval7: EPX_MIME_FIELD_MESSAGE_ID
			yyval8: EPX_MIME_FIELD_MIME_VERSION
			yyval1: STRING
			yyval10: INTEGER
			yyval9: EPX_MIME_PARAMETER
			yyval3: EPX_MIME_UNSTRUCTURED_FIELD
		do
			inspect yy_act
when 1 then
--|#line 108 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 108")
end
			yyval := yyval_default;
accept 

when 2 then
--|#line 109 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 109")
end
			yyval := yyval_default;
accept 

when 3 then
--|#line 114 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 114")
end
			yyval := yyval_default;


when 4 then
--|#line 115 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 115")
end
			yyval := yyval_default;


when 5 then
--|#line 123 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 123")
end

if yytype2 (yyvs.item (yyvsp)) /= Void then part.fields.put (yytype2 (yyvs.item (yyvsp)), yytype2 (yyvs.item (yyvsp)).name) end 
			yyval := yyval2
when 6 then
--|#line 125 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 125")
end

part.fields.put (yytype3 (yyvs.item (yyvsp)), yytype3 (yyvs.item (yyvsp)).name) 
			yyval := yyval2
when 7 then
--|#line 127 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 127")
end

stop_keyword 
			yyval := yyval2
when 8 then
--|#line 127 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 127")
end
			yyval := yyval_default;
reset_start_condition 

when 9 then
--|#line 133 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 133")
end

yyval2 := yytype4 (yyvs.item (yyvsp)) 
			yyval := yyval2
when 10 then
--|#line 135 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 135")
end

yyval2 := yytype6 (yyvs.item (yyvsp)) 
			yyval := yyval2
when 11 then
--|#line 137 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 137")
end

yyval2 := yytype5 (yyvs.item (yyvsp)) 
			yyval := yyval2
when 12 then
--|#line 139 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 139")
end


			yyval := yyval2
when 13 then
--|#line 140 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 140")
end


			yyval := yyval2
when 14 then
--|#line 141 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 141")
end

yyval2 := yytype7 (yyvs.item (yyvsp)) 
			yyval := yyval2
when 15 then
--|#line 143 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 143")
end

yyval2 := yytype8 (yyvs.item (yyvsp)) 
			yyval := yyval2
when 16 then
--|#line 145 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 145")
end


			yyval := yyval2
when 17 then
--|#line 146 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 146")
end


			yyval := yyval2
when 18 then
--|#line 147 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 147")
end


			yyval := yyval2
when 19 then
--|#line 148 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 148")
end


			yyval := yyval2
when 20 then
--|#line 149 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 149")
end


			yyval := yyval2
when 21 then
--|#line 150 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 150")
end


			yyval := yyval2
when 22 then
--|#line 151 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 151")
end


			yyval := yyval2
when 23 then
--|#line 158 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 158")
end

			yyval4 := my_content_disposition
			current_parameter_field := Void
		
			yyval := yyval4
when 24 then
--|#line 158 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 158")
end
			yyval := yyval_default;
start_keyword 

when 25 then
--|#line 158 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 158")
end
			yyval := yyval_default;
			create my_content_disposition.make (yytype1 (yyvs.item (yyvsp)))
			current_parameter_field := my_content_disposition
		

when 26 then
--|#line 173 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 173")
end

			create yyval6.make (yytype10 (yyvs.item (yyvsp)))
		
			yyval := yyval6
when 27 then
--|#line 173 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 173")
end
			yyval := yyval_default;
start_keyword 

when 28 then
--|#line 182 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 182")
end

			yyval5 := my_content_type
			current_parameter_field := Void
		
			yyval := yyval5
when 29 then
--|#line 182 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 182")
end
			yyval := yyval_default;
start_keyword 

when 30 then
--|#line 182 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 182")
end
			yyval := yyval_default;
			create my_content_type.make (yytype1 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp)))
			current_parameter_field := my_content_type
		

when 31 then
--|#line 197 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 197")
end
			yyval := yyval_default;


when 32 then
--|#line 197 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 197")
end
			yyval := yyval_default;
start_keyword 

when 33 then
--|#line 203 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 203")
end
			yyval := yyval_default;


when 34 then
--|#line 207 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 207")
end

create yyval7.make (yytype1 (yyvs.item (yyvsp))) 
			yyval := yyval7
when 35 then
--|#line 212 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 212")
end

create yyval8.make (yytype10 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp))) 
			yyval := yyval8
when 36 then
--|#line 212 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 212")
end
			yyval := yyval_default;
start_keyword 

when 37 then
--|#line 219 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 219")
end
			yyval := yyval_default;


when 38 then
--|#line 219 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 219")
end
			yyval := yyval_default;
start_keyword 

when 39 then
--|#line 219 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 219")
end
			yyval := yyval_default;
start_keyword 

when 40 then
--|#line 231 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 231")
end
			yyval := yyval_default;


when 41 then
--|#line 235 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 235")
end
			yyval := yyval_default;


when 42 then
--|#line 239 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 239")
end
			yyval := yyval_default;


when 43 then
--|#line 243 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 243")
end
			yyval := yyval_default;


when 44 then
--|#line 247 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 247")
end
			yyval := yyval_default;


when 45 then
--|#line 251 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 251")
end
			yyval := yyval_default;


when 46 then
--|#line 257 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 257")
end
			yyval := yyval_default;


when 47 then
--|#line 258 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 258")
end
			yyval := yyval_default;


when 48 then
--|#line 262 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 262")
end
			yyval := yyval_default;


when 49 then
--|#line 263 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 263")
end
			yyval := yyval_default;


when 50 then
--|#line 264 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 264")
end
			yyval := yyval_default;


when 51 then
--|#line 268 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 268")
end

		create yyval1.make_from_string (yytype1 (yyvs.item (yyvsp - 2)))
		yyval1.append_character ('@')
		yyval1.append_string (yytype1 (yyvs.item (yyvsp - 2)))
		
			yyval := yyval1
when 52 then
--|#line 277 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 277")
end

yyval1 := yytype1 (yyvs.item (yyvsp)) 
			yyval := yyval1
when 53 then
--|#line 282 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 282")
end
			yyval := yyval_default;


when 54 then
--|#line 286 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 286")
end
			yyval := yyval_default;


when 55 then
--|#line 290 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 290")
end
			yyval := yyval_default;


when 56 then
--|#line 294 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 294")
end
			yyval := yyval_default;


when 57 then
--|#line 295 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 295")
end
			yyval := yyval_default;


when 58 then
--|#line 296 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 296")
end
			yyval := yyval_default;


when 59 then
--|#line 297 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 297")
end
			yyval := yyval_default;


when 60 then
--|#line 298 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 298")
end
			yyval := yyval_default;


when 61 then
--|#line 299 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 299")
end
			yyval := yyval_default;


when 62 then
--|#line 300 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 300")
end
			yyval := yyval_default;


when 63 then
--|#line 301 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 301")
end
			yyval := yyval_default;


when 64 then
--|#line 305 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 305")
end

yyval1 := yytype1 (yyvs.item (yyvsp)) 
			yyval := yyval1
when 65 then
--|#line 307 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 307")
end

yyval1 := yytype1 (yyvs.item (yyvsp - 2)) + "." + yytype1 (yyvs.item (yyvsp)) 
			yyval := yyval1
when 66 then
--|#line 312 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 312")
end

yyval1 := yytype1 (yyvs.item (yyvsp)) 
			yyval := yyval1
when 67 then
--|#line 317 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 317")
end
			yyval := yyval_default;


when 68 then
--|#line 317 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 317")
end
			yyval := yyval_default;
start_encoded_text; 

when 69 then
--|#line 323 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 323")
end
			yyval := yyval_default;


when 70 then
--|#line 327 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 327")
end
			yyval := yyval_default;


when 71 then
--|#line 331 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 331")
end
			yyval := yyval_default;


when 72 then
--|#line 335 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 335")
end

		if yytype1 (yyvs.item (yyvsp)).is_integer then
			yyval10 := yytype1 (yyvs.item (yyvsp)).to_integer
		else
			abort
		end
		
			yyval := yyval10
when 73 then
--|#line 346 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 346")
end

yyval1 := yytype1 (yyvs.item (yyvsp)) 
			yyval := yyval1
when 74 then
--|#line 348 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 348")
end

yyval1 := yytype1 (yyvs.item (yyvsp - 2)) + "." + yytype1 (yyvs.item (yyvsp)) 
			yyval := yyval1
when 75 then
--|#line 353 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 353")
end
			yyval := yyval_default;


when 76 then
--|#line 354 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 354")
end
			yyval := yyval_default;


when 77 then
--|#line 358 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 358")
end
			yyval := yyval_default;


when 78 then
--|#line 359 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 359")
end
			yyval := yyval_default;


when 79 then
--|#line 360 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 360")
end
			yyval := yyval_default;


when 80 then
--|#line 364 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 364")
end

yyval1 := yytype1 (yyvs.item (yyvsp - 1)) 
			yyval := yyval1
when 81 then
--|#line 369 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 369")
end
			yyval := yyval_default;


when 82 then
--|#line 370 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 370")
end
			yyval := yyval_default;


when 83 then
--|#line 374 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 374")
end
			yyval := yyval_default;


when 84 then
--|#line 375 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 375")
end
			yyval := yyval_default;
stop_keyword 

when 85 then
--|#line 380 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 380")
end
			yyval := yyval_default;


when 86 then
--|#line 381 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 381")
end
			yyval := yyval_default;


when 87 then
--|#line 387 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 387")
end
			yyval := yyval_default;


when 88 then
--|#line 388 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 388")
end
			yyval := yyval_default;


when 89 then
--|#line 389 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 389")
end
			yyval := yyval_default;


when 90 then
--|#line 395 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 395")
end
			yyval := yyval_default;


when 91 then
--|#line 396 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 396")
end
			yyval := yyval_default;


when 92 then
--|#line 400 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 400")
end
			yyval := yyval_default;


when 93 then
--|#line 401 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 401")
end
			yyval := yyval_default;


when 94 then
--|#line 405 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 405")
end
			yyval := yyval_default;


when 95 then
--|#line 406 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 406")
end
			yyval := yyval_default;


when 96 then
--|#line 410 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 410")
end
			yyval := yyval_default;


when 97 then
--|#line 411 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 411")
end
			yyval := yyval_default;


when 98 then
--|#line 415 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 415")
end
			yyval := yyval_default;


when 99 then
--|#line 416 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 416")
end
			yyval := yyval_default;


when 100 then
--|#line 420 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 420")
end
			yyval := yyval_default;


when 101 then
--|#line 421 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 421")
end
			yyval := yyval_default;


when 102 then
--|#line 425 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 425")
end
			yyval := yyval_default;


when 103 then
--|#line 426 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 426")
end
			yyval := yyval_default;


when 104 then
--|#line 430 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 430")
end
			yyval := yyval_default;


when 105 then
--|#line 431 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 431")
end
			yyval := yyval_default;


when 106 then
--|#line 435 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 435")
end
			yyval := yyval_default;


when 107 then
--|#line 439 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 439")
end

			yytype1 (yyvs.item (yyvsp - 2)).to_lower
			create yyval9.make (yytype1 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp)))
			current_parameter_field.parameters.put (yyval9, yytype1 (yyvs.item (yyvsp - 2)))
		
			yyval := yyval9
when 108 then
--|#line 448 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 448")
end
			yyval := yyval_default;


when 109 then
--|#line 449 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 449")
end
			yyval := yyval_default;


when 110 then
--|#line 453 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 453")
end
			yyval := yyval_default;


when 111 then
--|#line 454 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 454")
end
			yyval := yyval_default;


when 112 then
--|#line 458 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 458")
end
			yyval := yyval_default;


when 113 then
--|#line 459 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 459")
end
			yyval := yyval_default;


when 114 then
--|#line 460 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 460")
end
			yyval := yyval_default;


when 115 then
--|#line 464 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 464")
end
			yyval := yyval_default;


when 116 then
--|#line 468 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 468")
end

yyval1  := yytype1 (yyvs.item (yyvsp)) 
			yyval := yyval1
when 117 then
--|#line 470 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 470")
end

yyval1 := yytype1 (yyvs.item (yyvsp)) 
			yyval := yyval1
when 118 then
--|#line 475 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 475")
end

yyval1 := yytype1 (yyvs.item (yyvsp)) 
			yyval := yyval1
when 119 then
--|#line 480 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 480")
end
			yyval := yyval_default;


when 120 then
--|#line 485 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 485")
end

yyval1 := yytype1 (yyvs.item (yyvsp)) 
			yyval := yyval1
when 121 then
--|#line 492 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 492")
end

			part.create_multipart_body
			yyval1 := "multipart"
		
			yyval := yyval1
when 122 then
--|#line 497 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 497")
end

			yyval1 := yytype1 (yyvs.item (yyvsp))
		
			yyval := yyval1
when 123 then
--|#line 504 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 504")
end

yyval1 := yytype1 (yyvs.item (yyvsp)) 
			yyval := yyval1
when 124 then
--|#line 506 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 506")
end

yyval1 := yytype1 (yyvs.item (yyvsp)) 
			yyval := yyval1
when 125 then
--|#line 511 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 511")
end
			yyval := yyval_default;


when 126 then
--|#line 512 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 512")
end
			yyval := yyval_default;


when 127 then
--|#line 516 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 516")
end

yyval1 := yytype1 (yyvs.item (yyvsp)) 
			yyval := yyval1
when 128 then
--|#line 518 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 518")
end

yyval1 := yytype1 (yyvs.item (yyvsp)) 
			yyval := yyval1
when 129 then
--|#line 523 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 523")
end
			yyval := yyval_default;


when 130 then
--|#line 524 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 524")
end
			yyval := yyval_default;


when 131 then
--|#line 531 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 531")
end
			yyval := yyval_default;


when 132 then
--|#line 537 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 537")
end

create yyval3.make (yytype1 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp))) 
			yyval := yyval3
			else
					-- No action
				yyval := yyval_default
			end
		end

feature {NONE} -- Table templates

	yytranslate_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,   45,    2,   43,   42,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,   41,   44,
			   48,   50,   49,   47,   46,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    1,    2,    3,    4,
			    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
			   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
			   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
			   35,   36,   37,   38,   39,   40>>)
		end

	yyr1_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    0,   73,   73,   74,   74,   51,   51,   51,   75,   53,
			   53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
			   53,   53,   53,   54,   85,   87,   56,   88,   55,   89,
			   90,   76,   92,   77,   57,   58,   94,   78,   96,  102,
			   79,   81,   80,   82,   83,   84,  106,  106,  103,  103,
			  103,   59,   60,  108,  109,   91,  112,  112,  112,  112,
			  112,  112,  112,  112,   61,   61,   62,  113,  115,  114,
			  107,  118,   71,   63,   63,  104,  104,   93,   93,   93,
			   64,   97,   97,  110,  110,  120,  120,  101,  101,  101,
			   95,   95,  100,  100,  117,  117,   86,   86,  122,  122,

			  119,  119,   98,   98,   99,   99,  125,   65,  121,  121,
			  116,  116,  123,  123,  123,  105,   66,   66,   67,  111,
			   68,   69,   69,   70,   70,  124,  124,   72,   72,  126,
			  126,  127,   52>>)
		end

	yyr2_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    0,    2,    2,    1,    2,    1,    1,    3,    0,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    6,    0,    0,    4,    0,    8,    0,
			    0,    4,    0,    3,    3,    6,    0,   12,    0,    0,
			    3,    3,    3,    3,    3,    3,    1,    1,    1,    1,
			    3,    3,    1,    1,    3,    3,    1,    1,    1,    1,
			    1,    1,    1,    0,    1,    3,    1,    8,    0,    1,
			    4,    4,    1,    1,    3,    1,    2,    1,    1,    3,
			    3,    0,    2,    0,    2,    0,    1,    0,    2,    4,
			    0,    3,    0,    2,    0,    1,    0,    1,    0,    1,

			    0,    2,    0,    2,    0,    1,    3,    3,    2,    3,
			    1,    2,    1,    1,    3,    4,    1,    1,    1,    2,
			    1,    1,    1,    1,    1,    2,    3,    1,    1,    1,
			    1,    1,    3>>)
		end

	yydefact_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    8,    0,    6,    5,
			    9,   11,   10,   14,   15,    0,   12,   13,   16,   17,
			   18,   19,   20,   21,   22,    0,   36,    0,    0,    0,
			    0,    0,    0,   38,    0,    0,   32,   29,   27,   24,
			    2,    0,    8,    4,    1,  132,    0,   48,    0,  128,
			  127,   75,    0,  129,   45,   46,   49,   47,  130,    0,
			  110,   44,    0,   42,   41,   77,   40,   78,   98,   43,
			   90,    0,   34,   33,   83,    0,    0,    0,    7,   72,
			    0,  120,   53,    0,    0,    0,    0,   94,   76,  129,

			  111,    0,    0,  112,    0,   99,  113,    0,   81,    0,
			   73,   62,   61,   60,   59,   58,   57,   56,   31,    0,
			    0,  121,  122,    0,   26,   25,    0,    0,  117,   66,
			   51,  116,   64,   74,   50,   95,    0,   79,    0,    0,
			    0,   85,    0,  102,   80,    0,    0,   84,    0,   96,
			   35,   69,    0,    0,   70,  106,  115,  114,   86,   91,
			   82,    0,  104,    0,    0,   55,    0,  118,   30,    0,
			   23,   97,   68,   65,  103,    0,   92,  105,   54,    0,
			  131,  119,   96,    0,  108,   52,    0,  125,    0,   87,
			  100,   28,    0,  109,    0,  126,   93,    0,    0,    0,

			   71,  124,  123,  107,   67,    0,   88,   39,  101,    0,
			   83,   89,   37,    0,    0,    0>>)
		end

	yydefgoto_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			   17,   18,   19,   20,   21,   22,   23,   24,   61,  183,
			  130,  131,   62,   82,  184,  132,  168,   92,  123,  203,
			   90,   63,  213,   25,   51,   26,   27,   28,   29,   30,
			   31,   32,   33,   34,   87,  170,  149,   86,   85,  182,
			  118,   84,   76,   56,  108,   80,  143,  162,  176,  189,
			  198,  210,   64,   77,   98,   66,   67,   93,  146,  119,
			  165,  120,   68,  152,  186,   72,  136,  166,  200,  159,
			  171,  104,  105,  177,  106,   70,  181>>)
		end

	yypact_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			   82,  137,  136,  135,  134,  133,  132,  131,  130,  129,
			  128,  127,  126,  125,  118,  116,  124,   66, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768,  122, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768,  117, -32768,    2,   16,   16,
			    2,    1,  110, -32768,  115,    1, -32768, -32768, -32768, -32768,
			 -32768,  112, -32768, -32768, -32768, -32768,  113, -32768,   97, -32768,
			 -32768, -32768,  114,   11, -32768, -32768,  111, -32768, -32768,    0,
			   16, -32768,  110, -32768, -32768, -32768, -32768,  109,    4, -32768,
			  121,   39, -32768, -32768,   -1,   -2,  113,   97, -32768, -32768,
			  102, -32768, -32768,  100,   21,   39,    2,    1, -32768, -32768,

			 -32768,    1,   21, -32768,   39, -32768,   99,   21,  120,   88,
			   95, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,  119,
			   94, -32768, -32768,   92, -32768, -32768,  113,   97, -32768, -32768,
			 -32768, -32768,   90, -32768, -32768, -32768,   84, -32768,   91,   80,
			    4,  108,   21,  106, -32768,  107,  105, -32768,  104,   65,
			 -32768, -32768,   76,   21, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768,  103,   79,  101,   75, -32768,   98, -32768, -32768,   97,
			 -32768, -32768, -32768, -32768, -32768,   96,   89, -32768, -32768,   93,
			 -32768, -32768,   65,   61,   65, -32768,   74,   79,   87,   81,
			   60, -32768,   42, -32768,   64, -32768, -32768,   -3,   55,   51,

			 -32768, -32768, -32768, -32768, -32768,   39, -32768, -32768, -32768,    6,
			   -1, -32768, -32768,   43,   23, -32768>>)
		end

	yypgoto_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,  -80, -32768,
			  -90, -32768,   57, -32768, -32768, -32768, -32768,  -85, -32768, -32768,
			  -73,  -70, -32768,  144, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768,  -33, -32768, -32768, -32768, -32768,
			  -64, -32768,  -37, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768,  -31,  -34,  123, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768,  -30, -32768, -32768, -32768, -32768,
			  -42, -32768,    8,  -46, -32768, -32768, -32768>>)
		end

	yytable_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			   99,  109,  125,   65,   71,   73,   65,   69,   83,   74,
			   69,  110,  138,  124,   60,  122,   59,  141,   60,   60,
			   59,   59,  121,  215,  139,  110,  117,  116,  115,  114,
			  113,  112,  111,   60,  110,   59,   58,   58,  129,  128,
			  100,   97,  151,  214,  -63,  205,   75,   57,   78,  103,
			  102,   58,  160,  150,   95,  211,   60,  -73,   59,   91,
			  135,  201,   65,  173,  137,  134,   69,   52,  208,   15,
			   14,   13,   12,   11,   10,    9,    8,    7,    6,    5,
			    4,    3,    2,   16,  185,   15,   14,   13,   12,   11,
			   10,    9,    8,    7,    6,    5,    4,    3,    2,  207,

			  204,  199,  197,    1,  196,  175,   -3,  202,  194,  169,
			  190,  192,  188,  187,   91,  180,  179,  206,  178,    1,
			  174,  167,  164,  172,  163,  209,  158,  110,  154,  156,
			   89,  161,  155,  153,  148,  110,  145,  144,   95,  147,
			  142,  195,  193,  107,  140,  126,  212,  127,  157,  191,
			    0,   88,  133,    0,  101,   55,   96,   49,   78,   48,
			   94,   53,   54,   81,   50,   79,   47,   46,   45,   44,
			   43,   42,   41,   40,   39,   38,   37,   36,   35>>)
		end

	yycheck_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			   70,   81,   87,   37,   38,   39,   40,   37,   45,   40,
			   40,   81,  102,   86,   17,   17,   19,  107,   17,   17,
			   19,   19,   24,    0,  104,   95,   27,   28,   29,   30,
			   31,   32,   33,   17,  104,   19,   35,   35,   17,   18,
			   70,   41,  127,    0,   45,   48,   45,   45,   48,   45,
			   46,   35,  142,  126,   43,   49,   17,   46,   19,   17,
			   97,   19,   96,  153,  101,   96,   96,    1,   17,    3,
			    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,
			   14,   15,   16,    1,  169,    3,    4,    5,    6,    7,
			    8,    9,   10,   11,   12,   13,   14,   15,   16,   44,

			   36,   41,   21,   37,   17,   26,   40,  192,   34,   44,
			   17,   50,   23,   17,   17,   17,   41,  197,   17,   37,
			   17,   17,   17,   47,   17,  205,   18,  197,   44,   49,
			   17,   25,   41,   43,   42,  205,   17,   49,   43,   45,
			   20,  187,  184,   22,   45,   43,  210,   47,  140,  182,
			   -1,   39,   95,   -1,   45,   38,   45,   41,   48,   41,
			   46,   17,   40,   48,   40,   42,   41,   41,   41,   41,
			   41,   41,   41,   41,   41,   41,   41,   41,   41>>)
		end

feature {NONE} -- Conversion

	yytype1 (v: ANY): STRING is
		require
			valid_type: yyis_type1 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type1 (v: ANY): BOOLEAN is
		local
			u: STRING
		do
			u ?= v
			Result := (u = v)
		end

	yytype2 (v: ANY): EPX_MIME_FIELD is
		require
			valid_type: yyis_type2 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type2 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_FIELD
		do
			u ?= v
			Result := (u = v)
		end

	yytype3 (v: ANY): EPX_MIME_UNSTRUCTURED_FIELD is
		require
			valid_type: yyis_type3 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type3 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_UNSTRUCTURED_FIELD
		do
			u ?= v
			Result := (u = v)
		end

	yytype4 (v: ANY): EPX_MIME_FIELD_CONTENT_DISPOSITION is
		require
			valid_type: yyis_type4 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type4 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_FIELD_CONTENT_DISPOSITION
		do
			u ?= v
			Result := (u = v)
		end

	yytype5 (v: ANY): EPX_MIME_FIELD_CONTENT_TYPE is
		require
			valid_type: yyis_type5 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type5 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_FIELD_CONTENT_TYPE
		do
			u ?= v
			Result := (u = v)
		end

	yytype6 (v: ANY): EPX_MIME_FIELD_CONTENT_LENGTH is
		require
			valid_type: yyis_type6 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type6 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_FIELD_CONTENT_LENGTH
		do
			u ?= v
			Result := (u = v)
		end

	yytype7 (v: ANY): EPX_MIME_FIELD_MESSAGE_ID is
		require
			valid_type: yyis_type7 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type7 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_FIELD_MESSAGE_ID
		do
			u ?= v
			Result := (u = v)
		end

	yytype8 (v: ANY): EPX_MIME_FIELD_MIME_VERSION is
		require
			valid_type: yyis_type8 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type8 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_FIELD_MIME_VERSION
		do
			u ?= v
			Result := (u = v)
		end

	yytype10 (v: ANY): INTEGER is
		require
			valid_type: yyis_type10 (v)
		local
			ref: INTEGER_REF
		do
			ref ?= v
			Result := ref.item
		end

	yyis_type10 (v: ANY): BOOLEAN is
		local
			u: INTEGER_REF
		do
			u ?= v
			Result := (u = v)
		end


feature {NONE} -- Constants

	yyFinal: INTEGER is 215
			-- Termination state id

	yyFlag: INTEGER is -32768
			-- Most negative INTEGER

	yyNtbase: INTEGER is 51
			-- Number of tokens

	yyLast: INTEGER is 178
			-- Upper bound of `yytable' and `yycheck'

	yyMax_token: INTEGER is 295
			-- Maximum token id
			-- (upper bound of `yytranslate'.)

	yyNsyms: INTEGER is 128
			-- Number of symbols
			-- (terminal and nonterminal)

feature -- User-defined features




feature -- Initialization

	make is
		do
			if last_line = Void then
				make_scanner
				precursor
				last_line := STRING_.make (128)
			end
			create part.make_empty
			level := 1
			boundary := Void
		end

	make_from_file (a_file: STDC_TEXT_FILE) is
		require
			file_not_void: a_file /= Void
			file_open: a_file.is_open
		do
			make
			a_file.set_no_buffering
			set_input_buffer (new_stdc_file_buffer (a_file))
		end

	make_from_file_descriptor (a_fd: ABSTRACT_FILE_DESCRIPTOR) is
		require
			file_descriptor_not_void: a_fd /= Void
			file_descriptor_open: a_fd.is_open
		do
			make
			set_input_buffer (new_file_descriptor_buffer (a_fd))
		end


feature -- Character reading

	eof: BOOLEAN is
			-- True if `read_character' hits end-of-file.
		do
			Result :=
				last_character = yyEnd_of_file_character and
				not input_buffer.filled
		end


feature {NONE} -- Scanning

	regular_buffer: YY_BUFFER
			-- Cache of `input_buffer', to be copied back on `wrap'.

	wrap: BOOLEAN is
			-- Check if we were parsing header, if so, resume with main
			-- buffer.
		do
			if regular_buffer /= Void then
				set_input_buffer (regular_buffer)
				regular_buffer := Void
			else
				Result := True
			end
		end


feature -- Access

	token_name (a_token: INTEGER): STRING is
			-- Name of token `a_token'
		do
			Result := mime_tokens.token_name (a_token)
		end


feature -- Parsing

	parse is
		local
			is_multipart_body: BOOLEAN
			multipart_body: EPX_MIME_BODY_MULTIPART
			save_part: EPX_MIME_PART
		do
			do_parse

			-- Be very careful in determining if we should parse a
			-- multipart body.
			is_multipart_body :=
				part.body /= Void and then part.body.is_multipart and then
				part.content_type /= Void and then part.content_type.parameters.has (part.parameter_name_boundary)
			if is_multipart_body then
				part.content_type.parameters.search (part.parameter_name_boundary)
				is_multipart_body := part.content_type.parameters.found
				if is_multipart_body then
					boundary := "--" + part.content_type.parameters.found_item.value
					is_multipart_body := boundary.count <= Max_rfc_2046_boundary_length + 2
				end
			end

			if is_multipart_body then
				-- some overflow test here in `level'?
				save_part := part
				multipart_body ?= save_part.body
				level := level + 1
				forward_to_boundary
				from
				until
					end_of_file or else
					eof or else
					boundary_with_trailer_read
				loop
					part := multipart_body.new_part
					parse
				end
				level := level - 1
				part := save_part
			else
				-- We get here to read a body which ends with eof or
				-- a mime boundary. Make sure we have a single part body.
				part.clear_body
				part.create_singlepart_body
				read_singlepart_body
			end
		end

	set_header (a_header: STRING) is
			-- Optional header that is parsed before the regular input
			-- is parsed.
		require
			a_header_not_empty: a_header /= Void and then not a_header.is_empty
		local
			string_buffer: YY_BUFFER
		do
			regular_buffer := input_buffer
			create string_buffer.make (a_header)
			set_input_buffer (string_buffer)
		end


feature {NONE} -- Error reporting

	report_error (a_message: STRING) is
			-- Dump error to stderr. Needs to be rewritten.
		do
			std.error.put_string ("line ")
			std.error.put_integer (line)
			std.error.put_string (", ")
			std.error.put_integer (column)
			std.error.put_string (": ")
			std.error.put_string (a_message)
			std.error.put_character ('%N')
			std.error.put_string ("  text: %"")
			if last_value /= Void then
				std.error.put_string (last_value)
			end
			std.error.put_string ("%" (")
			std.error.put_string (text)
			std.error.put_string (")%N")
			std.error.put_string ("  token: ")
			std.error.put_integer (last_token)
			std.error.put_character ('%N')
		end


feature -- State

	file: STDC_TEXT_FILE
			-- Where data comes from.

	part: EPX_MIME_PART
			-- Structure we're building.


feature {NONE} -- State used during parsing

	level: INTEGER

	my_content_disposition: EPX_MIME_FIELD_CONTENT_DISPOSITION

	my_content_type: EPX_MIME_FIELD_CONTENT_TYPE

	current_parameter_field: EPX_MIME_FIELD_WITH_PARAMETERS


feature {NONE} -- Reading mime bodies

	boundary: STRING
			-- For multipart MIME messages, it designates the end of a body.

	boundary_with_trailer_read: BOOLEAN

	determine_boundary_with_trailer_read is
			-- There was a boundary match, determine if two dashes follow
			-- (last boundary) and set `boundary_with_trailer_read' in that case.
		do
			-- NOTE: we've already read one character.
			boundary_with_trailer_read := last_character = '-'
			if boundary_with_trailer_read then
				read_character
				boundary_with_trailer_read := last_character = '-'
			end
		end

	forward_to_boundary is
			-- Move input cursor to line that contains `boundary'.
			-- Assume we start reading at beginning of a line.
		require
			boundary_not_empty: boundary /= Void and then not boundary.is_empty
		local
			boundary_read: BOOLEAN
			matching_boundary: BOOLEAN
			matched_index: INTEGER
			match: BOOLEAN
		do
			from
				matching_boundary := True
				matched_index := 1
				read_character
			until
				eof or else
				boundary_read
			loop
				if last_character = '%N' then
					-- Start matching beginning of boundary
					matching_boundary := True
					matched_index := 1
				else
					if matching_boundary then
						match := boundary.item (matched_index) = last_character
						if match then
							-- Match found, advance to next character.
							matched_index := matched_index + 1
							boundary_read := matched_index > boundary.count
						else
							-- Mismatch. As boundary has to match only at
							-- beginning of line, we just have a data line.
							matching_boundary := False
						end
					end
				end
				read_character
			end

			if boundary_read then
				determine_boundary_with_trailer_read
			end
			forward_to_end_of_line
		end

	forward_to_end_of_line is
			-- Always move cursor to next line.
		do
			from
			until
				eof or else
				last_character = '%N'
			loop
				read_character
			end
		ensure
			cursor_at_new_line: eof or else last_character = '%N'
		end

	is_text_body: BOOLEAN is
			-- Contains part.body text?
		local
			text_body: EPX_MIME_BODY_TEXT
		do
			text_body ?= part.body
			Result := text_body /= Void
		end

	last_line: STRING
			-- We store last read line here when reading multipart bodies

	Max_rfc_2046_boundary_length: INTEGER is 70
			-- Max length of a boundary according to RFC 2046

	read_singlepart_body is
			-- Read from input until end of file is reached or a line
			-- contains `boundary'.
		require
			body_not_void: part.body /= Void
			body_is_single_part: not part.body.is_multipart
		do
			if boundary = Void then
				read_singlepart_body_without_boundary
			else
				read_singlepart_body_with_boundary
			end
		end

	read_singlepart_body_with_boundary is
			-- Start reading a single part. This routine has to do two
			-- things right: it has to stop when a boundary has been
			-- parsed, and the cr+lf before the boundary is not part of
			-- the file.
		require
			boundary_is_set: boundary /= Void
			has_buffer: last_line /= Void
			body_contains_text: is_text_body
		local
			boundary_read: BOOLEAN
			matched_index: INTEGER
			match: BOOLEAN
			c: CHARACTER
			matching_boundary: BOOLEAN
			body: EPX_MIME_BODY_TEXT
			add_cr: BOOLEAN
		do
			body ?= part.body
			-- This loop reads data character by character.
			-- We have to stop when a boundary occurs after a CRLF.
			from
				matching_boundary := True
				last_line.wipe_out
				matched_index := 1
				read_character
			invariant
				matched_index >= 1
				not boundary_read implies matched_index <= boundary.count
				matching_boundary implies matched_index <= last_line.count + 1
			until
				eof or else
				boundary_read
			loop

				-- `c' contains the current character
				c := last_character

				inspect c
				when '%R' then
					-- when a CR is encountered, we've to check for a LF to
					-- know if this is an end of line or an incidental CR
					-- (pure data)
					last_line.append_character (c)
				when '%N' then
					-- the next line could contain the boundary so we don't
					-- write the (CR)LF, but keep it in `last_line'. The
					-- CRLF is part of the boundary in that case, not of
					-- the message.
					if last_line.count > 0 and then
						last_line.item (last_line.count) = '%R' then
						-- at this point a CRLF has been read
						last_line.remove (last_line.count)
						add_cr := True
					else
						add_cr := False
					end
					body.append_string (last_line)
					last_line.wipe_out
					if add_cr then
						last_line.append_character ('%R')
					end
					last_line.append_character (c)
					matched_index := 1
					matching_boundary := True
				else
					if matching_boundary then
						match := boundary.item (matched_index) = c
						if match then
							-- Match found, advance to next character.
							last_line.append_character (c)
							matched_index := matched_index + 1
							boundary_read := matched_index > boundary.count
						else
							-- Mismatch. As boundary has to match only at
							-- beginning of line, we just have a data line.
							body.append_string (last_line)
							body.append_character (c)
							last_line.wipe_out
							matching_boundary := False
						end
					else
						body.append_string (last_line)
						body.append_character (c)
						last_line.wipe_out
					end
				end

				-- very expensive check
					check
						-- last_line.has_substring (boundary) implies boundary_read
					end

				read_character
			end
			body.finish

			-- if boundary read, skip rest of line
			if boundary_read then
				determine_boundary_with_trailer_read
			end
			forward_to_end_of_line

				check
					stop_condition: boundary_read or eof
				end
		end

	read_singlepart_body_without_boundary is
			-- Read `file' until `end_of_file'. Does handle any line length.
		require
			body_contains_text: is_text_body
		local
			body: EPX_MIME_BODY_TEXT
		do
			body ?= part.body
			from
				read_character
			until
				eof
			loop
				body.append_character (last_character)
				read_character
			end
			body.finish
		ensure
			read_everything: eof
		end


invariant

	last_line_not_void: last_line /= Void

end
