indexing

	description: "Class that gets POSIX stat structure through stat call."

	author: "Berend de Boer"
	date: "$Date: 2003/01/09 $"
	revision: "$Revision: #3 $"

class

	POSIX_STATUS_PATH


inherit

	POSIX_STATUS

	ABSTRACT_STATUS_PATH
		export
			{POSIX_PERMISSIONS_PATH} path
		redefine
			make,
			refresh
		end

	PAPI_STAT


creation {EPX_FILE_SYSTEM}

	make


feature {EPX_FILE_SYSTEM} -- creation

	make (a_path: STRING) is
		do
			precursor (a_path)
		end


feature -- stat members

	permissions: POSIX_PERMISSIONS is
			-- file permissions
		do
			if my_permissions = Void then
				create {POSIX_PERMISSIONS_PATH} my_permissions.make (Current)
			end
			Result := my_permissions
		end


feature -- state change commands

	refresh is
			-- Refresh the cached status information
		do
			precursor
			if my_permissions /= Void then
				my_permissions.update_from_status
			end
		end


feature {NONE} -- state

	my_permissions: POSIX_PERMISSIONS


feature {NONE} -- abstract API

	abstract_stat (a_path: POINTER; a_stat: POINTER): INTEGER is
			-- Gets information about a file
		do
			Result := posix_stat (a_path, a_stat)
		end


end -- class POSIX_STATUS_PATH
